//Codec for this file is Windows-1251
//C++17

#include "Helper.h"
#include <wincon.h>

void ApiWriteAsOem(const char* c_str) {
    const ::HANDLE hOut = ::GetStdHandle(STD_OUTPUT_HANDLE);
    if( INVALID_HANDLE_VALUE == hOut )
        return;
    ::DWORD tmp, sz = ::lstrlenA(c_str);
    HeapBuffer<char> buf{sz+1};
    if( !buf.isValid() )
        return;
    if( ::CharToOemA(c_str, buf.get()) )
        ::WriteConsoleA(hOut, buf.get(), sz, &tmp, NULL);
}

bool FileOutput::close() const { //   ( 
//)
    if( m_isValid ) {
        m_isValid = false; //    
        return ::CloseHandle(m_hFile); //   
        //  
    } else
        return true;
}

bool FileOutput::write(const char* chars_buffer, unsigned long chars_to_write) {
    if( !m_isValid )
        return false;
    ::DWORD tmp;
    return ::WriteFile(m_hFile, static_cast<PCVOID>(chars_buffer),
        chars_to_write, &tmp, NULL);
}

